summaryrefslogtreecommitdiffstats
path: root/testsuite
diff options
context:
space:
mode:
Diffstat (limited to 'testsuite')
-rwxr-xr-xtestsuite/check.sh438
-rw-r--r--testsuite/dotdot1.tar.lzbin0 -> 139 bytes
-rw-r--r--testsuite/dotdot2.tar.lzbin0 -> 140 bytes
-rw-r--r--testsuite/dotdot3.tar.lzbin0 -> 141 bytes
-rw-r--r--testsuite/dotdot4.tar.lzbin0 -> 140 bytes
-rw-r--r--testsuite/dotdot5.tar.lzbin0 -> 139 bytes
-rw-r--r--testsuite/eof.tar.lzbin0 -> 44 bytes
-rw-r--r--testsuite/test.txt676
-rw-r--r--testsuite/test.txt.lzbin0 -> 7392 bytes
-rw-r--r--testsuite/test.txt.tarbin0 -> 38400 bytes
-rw-r--r--testsuite/test.txt.tar.lzbin0 -> 7495 bytes
-rw-r--r--testsuite/test3.tarbin0 -> 4096 bytes
-rw-r--r--testsuite/test3.tar.lzbin0 -> 356 bytes
-rw-r--r--testsuite/test3_bad1.tarbin0 -> 4096 bytes
-rw-r--r--testsuite/test3_bad1.tar.lzbin0 -> 356 bytes
-rw-r--r--testsuite/test3_bad2.tarbin0 -> 4096 bytes
-rw-r--r--testsuite/test3_bad2.tar.lzbin0 -> 356 bytes
-rw-r--r--testsuite/test3_bad3.tarbin0 -> 4096 bytes
-rw-r--r--testsuite/test3_bad3.tar.lzbin0 -> 356 bytes
-rw-r--r--testsuite/test3_bad4.tarbin0 -> 4096 bytes
-rw-r--r--testsuite/test3_bad4.tar.lzbin0 -> 356 bytes
-rw-r--r--testsuite/test3_bad5.tarbin0 -> 4608 bytes
-rw-r--r--testsuite/test3_bad5.tar.lzbin0 -> 356 bytes
-rw-r--r--testsuite/test3_bad6.tar.lzbin0 -> 866 bytes
-rw-r--r--testsuite/test3a.tar.lzbin0 -> 358 bytes
25 files changed, 1114 insertions, 0 deletions
diff --git a/testsuite/check.sh b/testsuite/check.sh
new file mode 100755
index 0000000..07b0d34
--- /dev/null
+++ b/testsuite/check.sh
@@ -0,0 +1,438 @@
+#! /bin/sh
+# check script for Tarlz - Archiver with multimember lzip compression
+# Copyright (C) 2013-2018 Antonio Diaz Diaz.
+#
+# This script is free software: you have unlimited permission
+# to copy, distribute and modify it.
+
+LC_ALL=C
+export LC_ALL
+objdir=`pwd`
+testdir=`cd "$1" ; pwd`
+TARLZ="${objdir}"/tarlz
+framework_failure() { echo "failure in testing framework" ; exit 1 ; }
+
+if [ ! -f "${TARLZ}" ] || [ ! -x "${TARLZ}" ] ; then
+ echo "${TARLZ}: cannot execute"
+ exit 1
+fi
+
+[ -e "${TARLZ}" ] 2> /dev/null ||
+ {
+ echo "$0: a POSIX shell is required to run the tests"
+ echo "Try bash -c \"$0 $1 $2\""
+ exit 1
+ }
+
+if [ -d tmp ] ; then rm -rf tmp ; fi
+mkdir tmp
+cd "${objdir}"/tmp || framework_failure
+
+in="${testdir}"/test.txt
+in_lz="${testdir}"/test.txt.lz
+in_tar="${testdir}"/test.txt.tar
+in_tar_lz="${testdir}"/test.txt.tar.lz
+test3="${testdir}"/test3.tar
+test3_lz="${testdir}"/test3.tar.lz
+test3a_lz="${testdir}"/test3a.tar.lz
+bad1="${testdir}"/test3_bad1.tar
+bad2="${testdir}"/test3_bad2.tar
+bad3="${testdir}"/test3_bad3.tar
+bad4="${testdir}"/test3_bad4.tar
+bad5="${testdir}"/test3_bad5.tar
+bad1_lz="${testdir}"/test3_bad1.tar.lz
+bad2_lz="${testdir}"/test3_bad2.tar.lz
+bad3_lz="${testdir}"/test3_bad3.tar.lz
+bad4_lz="${testdir}"/test3_bad4.tar.lz
+bad5_lz="${testdir}"/test3_bad5.tar.lz
+bad6_lz="${testdir}"/test3_bad6.tar.lz
+eof_lz="${testdir}"/eof.tar.lz
+fail=0
+test_failed() { fail=1 ; printf " $1" ; [ -z "$2" ] || printf "($2)" ; }
+
+# Description of test files for lziprecover:
+# test3.tar: 3 members (foo bar baz) + 2 zeroed 512-byte blocks
+# test3_bad1.tar: byte at offset 259 changed from 't' to '0' (magic)
+# test3_bad2.tar: byte at offset 1283 changed from 't' to '0' (magic)
+# test3_bad3.tar: byte at offset 2559 changed from 0x00 to 0x20 (padding)
+# test3_bad4.tar: byte at offset 1283 changed from 't' to '0' (magic)
+# byte at offset 2307 changed from 't' to '0' (magic)
+# test3_bad5.tar: 510 zeros + "LZ" prepended to test3.tar (bogus lz header)
+# test3_bad1.tar.lz: byte at offset 2 changed from 'I' to 'i' (magic)
+# test3_bad2.tar.lz: byte at offset 49 changed from 0x49 to 0x69 (mid stream)
+# test3_bad3.tar.lz: byte at offset 149 changed from 0x2D to 0x3D (mid stream)
+# test3_bad4.tar.lz: combined damage of test3_bad2.tar.lz and test3_bad3.tar.lz
+# test3_bad5.tar.lz: [71-134] --> zeroed (first trailer + seconf header)
+# test3_bad6.tar.lz: 510 zeros prepended to test3.tar.lz (header in two blocks)
+
+printf "testing tarlz-%s..." "$2"
+
+"${TARLZ}" -qtf ${in}
+[ $? = 2 ] || test_failed $LINENO
+"${TARLZ}" -qtf ${in_lz}
+[ $? = 2 ] || test_failed $LINENO
+"${TARLZ}" -qtf nx_file
+[ $? = 1 ] || test_failed $LINENO
+"${TARLZ}" -tf 2> /dev/null
+[ $? = 1 ] || test_failed $LINENO
+"${TARLZ}" -qcf out.tar.lz
+[ $? = 1 ] || test_failed $LINENO
+[ ! -e out.tar.lz ] || test_failed $LINENO
+"${TARLZ}" -rf out.tar.lz || test_failed $LINENO
+[ ! -e out.tar.lz ] || test_failed $LINENO
+"${TARLZ}" -qrf - ${in}
+[ $? = 1 ] || test_failed $LINENO
+[ ! -e - ] || test_failed $LINENO
+"${TARLZ}" -qr ${in}
+[ $? = 1 ] || test_failed $LINENO
+"${TARLZ}" --uncompressed -qrf out.tar ${in}
+[ $? = 1 ] || test_failed $LINENO
+[ ! -e out.tar ] || test_failed $LINENO
+cat ${test3_lz} > test.tar.lz || framework_failure
+"${TARLZ}" --uncompressed -qrf test.tar.lz ${in}
+[ $? = 1 ] || test_failed $LINENO
+cmp ${test3_lz} test.tar.lz || test_failed $LINENO
+rm -f test.tar.lz || framework_failure
+cat ${test3} > test.tar || framework_failure
+"${TARLZ}" -qrf test.tar ${in}
+[ $? = 2 ] || test_failed $LINENO
+cmp ${test3} test.tar || test_failed $LINENO
+rm -f test.tar || framework_failure
+"${TARLZ}" -qc ${in} nx_file > /dev/null
+[ $? = 1 ] || test_failed $LINENO
+"${TARLZ}" -qc -C nx_dir ${in}
+[ $? = 1 ] || test_failed $LINENO
+"${TARLZ}" -qx -C nx_dir ${test3_lz}
+[ $? = 1 ] || test_failed $LINENO
+"${TARLZ}" -qcr
+[ $? = 1 ] || test_failed $LINENO
+"${TARLZ}" -qct
+[ $? = 1 ] || test_failed $LINENO
+"${TARLZ}" -qcx
+[ $? = 1 ] || test_failed $LINENO
+"${TARLZ}" -qtx
+[ $? = 1 ] || test_failed $LINENO
+"${TARLZ}" -qctx
+[ $? = 1 ] || test_failed $LINENO
+"${TARLZ}" --help > /dev/null || test_failed $LINENO
+"${TARLZ}" -V > /dev/null || test_failed $LINENO
+"${TARLZ}" --bad_option -tf ${test3_lz} 2> /dev/null
+[ $? = 1 ] || test_failed $LINENO
+"${TARLZ}" -tf 2> /dev/null
+[ $? = 1 ] || test_failed $LINENO
+"${TARLZ}" --owner=invalid_oner_name -tf ${test3_lz} 2> /dev/null
+[ $? = 1 ] || test_failed $LINENO
+"${TARLZ}" --group=invalid_goup_name -tf ${test3_lz} 2> /dev/null
+[ $? = 1 ] || test_failed $LINENO
+
+"${TARLZ}" -tf ${eof_lz} || test_failed $LINENO
+"${TARLZ}" -xf ${eof_lz} || test_failed $LINENO
+"${TARLZ}" -tf ${in_tar_lz} > /dev/null || test_failed $LINENO
+"${TARLZ}" -xf ${in_tar_lz} || test_failed $LINENO
+cmp ${in} test.txt || test_failed $LINENO
+rm -f test.txt || framework_failure
+"${TARLZ}" -C nx_dir -tf ${in_tar} > /dev/null || test_failed $LINENO
+"${TARLZ}" -xf ${in_tar} || test_failed $LINENO
+cmp ${in} test.txt || test_failed $LINENO
+rm -f test.txt || framework_failure
+
+rm -f foo bar baz || framework_failure
+"${TARLZ}" -xf ${test3_lz} || test_failed $LINENO
+[ -e foo ] || test_failed $LINENO
+[ -e bar ] || test_failed $LINENO
+[ -e baz ] || test_failed $LINENO
+rm -f foo bar baz || framework_failure
+"${TARLZ}" -xf ${test3} || test_failed $LINENO
+[ -e foo ] || test_failed $LINENO
+[ -e bar ] || test_failed $LINENO
+[ -e baz ] || test_failed $LINENO
+rm -f foo bar baz || framework_failure
+"${TARLZ}" -qxf ${test3a_lz} || test_failed $LINENO
+[ -e dir/foo ] || test_failed $LINENO
+[ -e dir/bar ] || test_failed $LINENO
+[ -e dir/baz ] || test_failed $LINENO
+rm -rf dir || framework_failure
+
+cat ${in} > test.txt || framework_failure
+"${TARLZ}" -0 -cf out.tar.lz test.txt || test_failed $LINENO
+rm -f test.txt || framework_failure
+"${TARLZ}" -xf out.tar.lz || test_failed $LINENO
+cmp ${in} test.txt || test_failed $LINENO
+cat ${in} > test.txt || framework_failure
+"${TARLZ}" --uncompressed -cf out.tar test.txt || test_failed $LINENO
+rm -f test.txt || framework_failure
+"${TARLZ}" -xf out.tar || test_failed $LINENO
+cmp ${in} test.txt || test_failed $LINENO
+rm -f test.txt out.tar out.tar.lz || framework_failure
+
+printf "foo" > foo || framework_failure
+rm -f bar || framework_failure
+printf "baz" > baz || framework_failure
+"${TARLZ}" -qcf out.tar.lz foo bar baz
+[ $? = 1 ] || test_failed $LINENO
+rm -f foo bar baz || framework_failure
+"${TARLZ}" -xf out.tar.lz || test_failed $LINENO
+[ -e foo ] || test_failed $LINENO
+[ ! -e bar ] || test_failed $LINENO
+[ -e baz ] || test_failed $LINENO
+rm -f foo bar baz || framework_failure
+"${TARLZ}" -qxf out.tar.lz bar
+[ $? = 1 ] || test_failed $LINENO
+[ ! -e foo ] || test_failed $LINENO
+[ ! -e bar ] || test_failed $LINENO
+[ ! -e baz ] || test_failed $LINENO
+rm -f out.tar.lz || framework_failure
+
+printf "foo" > foo || framework_failure
+printf "bar" > bar || framework_failure
+printf "baz" > baz || framework_failure
+"${TARLZ}" -0 -cf out.tar.lz foo bar baz || test_failed $LINENO
+"${TARLZ}" --dsolid -0 -cf aout.tar.lz foo bar baz || test_failed $LINENO
+cmp out.tar.lz aout.tar.lz || test_failed $LINENO
+rm -f aout.tar.lz || framework_failure
+"${TARLZ}" -0 -qcf aout.tar.lz foo/ ./bar ./baz/ || test_failed $LINENO
+cmp out.tar.lz aout.tar.lz || test_failed $LINENO
+rm -f aout.tar.lz || framework_failure
+"${TARLZ}" -0 -cf aout.tar.lz foo || test_failed $LINENO
+"${TARLZ}" -0 -rf aout.tar.lz bar baz || test_failed $LINENO
+cmp out.tar.lz aout.tar.lz || test_failed $LINENO
+rm -f aout.tar.lz || framework_failure
+touch aout.tar.lz || framework_failure # append to empty file
+"${TARLZ}" -0 -rf aout.tar.lz foo bar baz || test_failed $LINENO
+cmp out.tar.lz aout.tar.lz || test_failed $LINENO
+"${TARLZ}" -0 -rf aout.tar.lz || test_failed $LINENO # append nothing
+cmp out.tar.lz aout.tar.lz || test_failed $LINENO
+"${TARLZ}" -0 -rf aout.tar.lz -C nx_dir || test_failed $LINENO
+cmp out.tar.lz aout.tar.lz || test_failed $LINENO
+"${TARLZ}" -0 -qrf aout.tar.lz nx_file
+[ $? = 1 ] || test_failed $LINENO
+cmp out.tar.lz aout.tar.lz || test_failed $LINENO
+cat ${eof_lz} > aout.tar.lz || framework_failure # append to empty archive
+"${TARLZ}" -0 -rf aout.tar.lz foo bar baz || test_failed $LINENO
+cmp out.tar.lz aout.tar.lz || test_failed $LINENO
+mv -f foo foo.orig || framework_failure
+mv -f bar bar.orig || framework_failure
+mv -f baz baz.orig || framework_failure
+"${TARLZ}" -xf out.tar.lz foo/ bar// baz/// || test_failed $LINENO
+cmp foo foo.orig || test_failed $LINENO
+cmp bar bar.orig || test_failed $LINENO
+cmp baz baz.orig || test_failed $LINENO
+rm -f foo bar baz || framework_failure
+"${TARLZ}" -xf out.tar.lz || test_failed $LINENO
+cmp foo foo.orig || test_failed $LINENO
+cmp bar bar.orig || test_failed $LINENO
+cmp baz baz.orig || test_failed $LINENO
+mkdir dir1 || framework_failure
+"${TARLZ}" -C dir1 -xf out.tar.lz || test_failed $LINENO
+cmp dir1/foo foo.orig || test_failed $LINENO
+cmp dir1/bar bar.orig || test_failed $LINENO
+cmp dir1/baz baz.orig || test_failed $LINENO
+rm -f aout.tar.lz foo bar baz || framework_failure
+"${TARLZ}" -C dir1 -0 -cf aout.tar.lz foo bar baz || test_failed $LINENO
+"${TARLZ}" -xf aout.tar.lz || test_failed $LINENO
+cmp foo foo.orig || test_failed $LINENO
+cmp bar bar.orig || test_failed $LINENO
+cmp baz baz.orig || test_failed $LINENO
+rm -f aout.tar.lz foo bar baz || framework_failure
+"${TARLZ}" -C dir1 -0 -c foo bar baz | "${TARLZ}" -x || test_failed $LINENO
+cmp foo foo.orig || test_failed $LINENO
+cmp bar bar.orig || test_failed $LINENO
+cmp baz baz.orig || test_failed $LINENO
+rm -f dir1/foo dir1/bar dir1/baz || framework_failure
+"${TARLZ}" -0 -c foo bar baz | "${TARLZ}" -C dir1 -x || test_failed $LINENO
+cmp dir1/foo foo.orig || test_failed $LINENO
+cmp dir1/bar bar.orig || test_failed $LINENO
+cmp dir1/baz baz.orig || test_failed $LINENO
+rm -f dir1/foo dir1/bar dir1/baz || framework_failure
+"${TARLZ}" -0 -c foo bar baz | "${TARLZ}" -x foo bar baz -C dir1 ||
+ test_failed $LINENO
+cmp dir1/foo foo.orig || test_failed $LINENO
+cmp dir1/bar bar.orig || test_failed $LINENO
+cmp dir1/baz baz.orig || test_failed $LINENO
+rm -f foo dir1/bar baz || framework_failure
+"${TARLZ}" -0 -cf aout.tar.lz -C dir1 foo -C .. bar -C dir1 baz ||
+ test_failed $LINENO
+cmp out.tar.lz aout.tar.lz || test_failed $LINENO
+"${TARLZ}" -0 -cf aout.tar.lz dir1/foo dir1/baz || test_failed $LINENO
+rm -rf dir1 || framework_failure
+"${TARLZ}" -xf aout.tar.lz dir1 || test_failed $LINENO
+cmp dir1/foo foo.orig || test_failed $LINENO
+cmp dir1/baz baz.orig || test_failed $LINENO
+rm -rf dir1 || framework_failure
+rm -f out.tar.lz aout.tar.lz || framework_failure
+
+# append to solid archive
+printf "foo" > foo || framework_failure
+printf "bar" > bar || framework_failure
+printf "baz" > baz || framework_failure
+"${TARLZ}" --solid -0 -cf out.tar.lz foo || test_failed $LINENO
+for i in --asolid --dsolid --solid -0 ; do
+ "${TARLZ}" $i -qrf out.tar.lz bar baz
+ [ $? = 2 ] || test_failed $LINENO $i
+ [ -e out.tar.lz ] || test_failed $LINENO $i
+done
+rm -f out.tar.lz || framework_failure
+for i in --asolid --dsolid -0 ; do
+ for j in --asolid --dsolid --solid -0 ; do
+ "${TARLZ}" $i -0 -cf out.tar.lz foo ||
+ test_failed $LINENO "$i $j"
+ "${TARLZ}" $j -0 -rf out.tar.lz bar baz ||
+ test_failed $LINENO "$i $j"
+ rm -f foo bar baz || framework_failure
+ "${TARLZ}" -xf out.tar.lz || test_failed $LINENO "$i $j"
+ cmp foo foo.orig || test_failed $LINENO "$i $j"
+ cmp bar bar.orig || test_failed $LINENO "$i $j"
+ cmp baz baz.orig || test_failed $LINENO "$i $j"
+ rm -f out.tar.lz || framework_failure
+ done
+done
+rm -f foo foo.orig bar bar.orig baz baz.orig || framework_failure
+
+mkdir dir1 || framework_failure
+"${TARLZ}" -0 -cf out.tar dir1 || test_failed $LINENO
+rmdir dir1 || framework_failure
+"${TARLZ}" -xf out.tar || test_failed $LINENO
+[ -d dir1 ] || test_failed $LINENO
+rmdir dir1
+mkdir dir1 || framework_failure
+"${TARLZ}" --uncompressed -cf out.tar dir1 || test_failed $LINENO
+rmdir dir1 || framework_failure
+"${TARLZ}" -xf out.tar || test_failed $LINENO
+[ -d dir1 ] || test_failed $LINENO
+rmdir dir1
+rm -f out.tar || framework_failure
+
+if ln ${in} dummy_link 2> /dev/null &&
+ ln -s ${in} dummy_slink 2> /dev/null ; then
+ name_100=name_100_bytes_long_nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn
+ path_100=dir1/dir2/dir3/path_100_bytes_long_nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn
+ path_106=dir1/dir2/dir3/path_longer_than_100_bytes_nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn
+ mkdir dir1 || framework_failure
+ mkdir dir1/dir2 || framework_failure
+ mkdir dir1/dir2/dir3 || framework_failure
+ cat ${in} > dir1/dir2/dir3/in || framework_failure
+ ln dir1/dir2/dir3/in dir1/dir2/dir3/${name_100} || framework_failure
+ ln dir1/dir2/dir3/in ${path_100} || framework_failure
+ ln dir1/dir2/dir3/in ${path_106} || framework_failure
+ ln -s in dir1/dir2/dir3/link || framework_failure
+ ln -s ${name_100} dir1/dir2/dir3/link_100 || framework_failure
+ "${TARLZ}" -0 -cf out.tar dir1 || test_failed $LINENO
+ rm -rf dir1 || framework_failure
+ "${TARLZ}" -xf out.tar || test_failed $LINENO
+ cmp ${in} dir1/dir2/dir3/in || test_failed $LINENO
+ cmp ${in} dir1/dir2/dir3/${name_100} || test_failed $LINENO
+ cmp ${in} ${path_100} || test_failed $LINENO
+ cmp ${in} ${path_106} || test_failed $LINENO
+ cmp ${in} dir1/dir2/dir3/link || test_failed $LINENO
+ cmp ${in} dir1/dir2/dir3/link_100 || test_failed $LINENO
+ rm -f dir1/dir2/dir3/in || framework_failure
+ cmp ${in} dir1/dir2/dir3/link 2> /dev/null && test_failed $LINENO
+ cmp ${in} dir1/dir2/dir3/link_100 || test_failed $LINENO
+ "${TARLZ}" -xf out.tar || test_failed $LINENO
+ rm -f out.tar || framework_failure
+ cmp ${in} dir1/dir2/dir3/in || test_failed $LINENO
+ cmp ${in} dir1/dir2/dir3/link || test_failed $LINENO
+ "${TARLZ}" -0 -qc ../tmp/dir1 > /dev/null || test_failed $LINENO
+ rm -rf dir1 || framework_failure
+else
+ printf "\nwarning: skipping link test: 'ln' does not work on your system."
+fi
+rm -f dummy_link dummy_slink || framework_failure
+
+"${TARLZ}" -qxf "${testdir}"/dotdot1.tar.lz || test_failed $LINENO
+[ ! -e ../dir ] || test_failed $LINENO
+"${TARLZ}" -qxf "${testdir}"/dotdot2.tar.lz || test_failed $LINENO
+[ ! -e ../dir ] || test_failed $LINENO
+"${TARLZ}" -qxf "${testdir}"/dotdot3.tar.lz || test_failed $LINENO
+[ ! -e dir ] || test_failed $LINENO
+"${TARLZ}" -qxf "${testdir}"/dotdot4.tar.lz || test_failed $LINENO
+[ ! -e dir ] || test_failed $LINENO
+"${TARLZ}" -qxf "${testdir}"/dotdot5.tar.lz || test_failed $LINENO
+[ ! -e dir ] || test_failed $LINENO
+
+printf "\ntesting bad input..."
+
+dd if=${in_tar} of=truncated.tar bs=1000 count=1 2> /dev/null
+"${TARLZ}" -qtf truncated.tar > /dev/null
+[ $? = 2 ] || test_failed $LINENO
+"${TARLZ}" -qxf truncated.tar
+[ $? = 2 ] || test_failed $LINENO
+[ ! -e test.txt ] || test_failed $LINENO
+
+rm -f foo bar baz || framework_failure
+"${TARLZ}" -qxf ${bad1_lz}
+[ $? = 2 ] || test_failed $LINENO
+[ ! -e foo ] || test_failed $LINENO
+[ -e bar ] || test_failed $LINENO
+[ -e baz ] || test_failed $LINENO
+rm -f foo bar baz || framework_failure
+"${TARLZ}" -qxf ${bad2_lz}
+[ $? = 2 ] || test_failed $LINENO
+[ ! -e foo ] || test_failed $LINENO
+[ -e bar ] || test_failed $LINENO
+[ -e baz ] || test_failed $LINENO
+rm -f foo bar baz || framework_failure
+"${TARLZ}" -qxf ${bad3_lz}
+[ $? = 2 ] || test_failed $LINENO
+[ -e foo ] || test_failed $LINENO
+[ ! -e bar ] || test_failed $LINENO
+[ -e baz ] || test_failed $LINENO
+rm -f foo bar baz || framework_failure
+"${TARLZ}" -qxf ${bad4_lz}
+[ $? = 2 ] || test_failed $LINENO
+[ ! -e foo ] || test_failed $LINENO
+[ ! -e bar ] || test_failed $LINENO
+[ -e baz ] || test_failed $LINENO
+rm -f foo bar baz || framework_failure
+"${TARLZ}" -qxf ${bad5_lz}
+[ $? = 2 ] || test_failed $LINENO
+[ ! -e foo ] || test_failed $LINENO
+[ ! -e bar ] || test_failed $LINENO
+[ -e baz ] || test_failed $LINENO
+rm -f foo bar baz || framework_failure
+"${TARLZ}" -qxf ${bad6_lz}
+[ $? = 2 ] || test_failed $LINENO
+[ -e foo ] || test_failed $LINENO
+[ -e bar ] || test_failed $LINENO
+[ -e baz ] || test_failed $LINENO
+
+rm -f foo bar baz || framework_failure
+"${TARLZ}" -qxf ${bad1}
+[ $? = 2 ] || test_failed $LINENO
+[ ! -e foo ] || test_failed $LINENO
+[ -e bar ] || test_failed $LINENO
+[ -e baz ] || test_failed $LINENO
+rm -f foo bar baz || framework_failure
+"${TARLZ}" -qxf ${bad2}
+[ $? = 2 ] || test_failed $LINENO
+[ -e foo ] || test_failed $LINENO
+[ ! -e bar ] || test_failed $LINENO
+[ -e baz ] || test_failed $LINENO
+rm -f foo bar baz || framework_failure
+"${TARLZ}" -qxf ${bad3}
+[ $? = 2 ] || test_failed $LINENO
+[ -e foo ] || test_failed $LINENO
+[ -e bar ] || test_failed $LINENO
+[ ! -e baz ] || test_failed $LINENO
+rm -f foo bar baz || framework_failure
+"${TARLZ}" -qxf ${bad4}
+[ $? = 2 ] || test_failed $LINENO
+[ -e foo ] || test_failed $LINENO
+[ ! -e bar ] || test_failed $LINENO
+[ ! -e baz ] || test_failed $LINENO
+rm -f foo bar baz || framework_failure
+"${TARLZ}" -qxf ${bad5}
+[ $? = 2 ] || test_failed $LINENO
+[ -e foo ] || test_failed $LINENO
+[ -e bar ] || test_failed $LINENO
+[ -e baz ] || test_failed $LINENO
+rm -f foo bar baz || framework_failure
+
+echo
+if [ ${fail} = 0 ] ; then
+ echo "tests completed successfully."
+ cd "${objdir}" && rm -r tmp
+else
+ echo "tests failed."
+fi
+exit ${fail}
diff --git a/testsuite/dotdot1.tar.lz b/testsuite/dotdot1.tar.lz
new file mode 100644
index 0000000..9884d9f
--- /dev/null
+++ b/testsuite/dotdot1.tar.lz
Binary files differ
diff --git a/testsuite/dotdot2.tar.lz b/testsuite/dotdot2.tar.lz
new file mode 100644
index 0000000..a60b898
--- /dev/null
+++ b/testsuite/dotdot2.tar.lz
Binary files differ
diff --git a/testsuite/dotdot3.tar.lz b/testsuite/dotdot3.tar.lz
new file mode 100644
index 0000000..163fb5c
--- /dev/null
+++ b/testsuite/dotdot3.tar.lz
Binary files differ
diff --git a/testsuite/dotdot4.tar.lz b/testsuite/dotdot4.tar.lz
new file mode 100644
index 0000000..8c6a0ee
--- /dev/null
+++ b/testsuite/dotdot4.tar.lz
Binary files differ
diff --git a/testsuite/dotdot5.tar.lz b/testsuite/dotdot5.tar.lz
new file mode 100644
index 0000000..a62cd18
--- /dev/null
+++ b/testsuite/dotdot5.tar.lz
Binary files differ
diff --git a/testsuite/eof.tar.lz b/testsuite/eof.tar.lz
new file mode 100644
index 0000000..328273c
--- /dev/null
+++ b/testsuite/eof.tar.lz
Binary files differ
diff --git a/testsuite/test.txt b/testsuite/test.txt
new file mode 100644
index 0000000..9196a3a
--- /dev/null
+++ b/testsuite/test.txt
@@ -0,0 +1,676 @@
+ GNU GENERAL PUBLIC LICENSE
+ Version 2, June 1991
+
+ Copyright (C) 1989, 1991 Free Software Foundation, Inc.,
+ 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+ Preamble
+
+ The licenses for most software are designed to take away your
+freedom to share and change it. By contrast, the GNU General Public
+License is intended to guarantee your freedom to share and change free
+software--to make sure the software is free for all its users. This
+General Public License applies to most of the Free Software
+Foundation's software and to any other program whose authors commit to
+using it. (Some other Free Software Foundation software is covered by
+the GNU Lesser General Public License instead.) You can apply it to
+your programs, too.
+
+ When we speak of free software, we are referring to freedom, not
+price. Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+this service if you wish), that you receive source code or can get it
+if you want it, that you can change the software or use pieces of it
+in new free programs; and that you know you can do these things.
+
+ To protect your rights, we need to make restrictions that forbid
+anyone to deny you these rights or to ask you to surrender the rights.
+These restrictions translate to certain responsibilities for you if you
+distribute copies of the software, or if you modify it.
+
+ For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must give the recipients all the rights that
+you have. You must make sure that they, too, receive or can get the
+source code. And you must show them these terms so they know their
+rights.
+
+ We protect your rights with two steps: (1) copyright the software, and
+(2) offer you this license which gives you legal permission to copy,
+distribute and/or modify the software.
+
+ Also, for each author's protection and ours, we want to make certain
+that everyone understands that there is no warranty for this free
+software. If the software is modified by someone else and passed on, we
+want its recipients to know that what they have is not the original, so
+that any problems introduced by others will not reflect on the original
+authors' reputations.
+
+ Finally, any free program is threatened constantly by software
+patents. We wish to avoid the danger that redistributors of a free
+program will individually obtain patent licenses, in effect making the
+program proprietary. To prevent this, we have made it clear that any
+patent must be licensed for everyone's free use or not licensed at all.
+
+ The precise terms and conditions for copying, distribution and
+modification follow.
+
+ GNU GENERAL PUBLIC LICENSE
+ TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+ 0. This License applies to any program or other work which contains
+a notice placed by the copyright holder saying it may be distributed
+under the terms of this General Public License. The "Program", below,
+refers to any such program or work, and a "work based on the Program"
+means either the Program or any derivative work under copyright law:
+that is to say, a work containing the Program or a portion of it,
+either verbatim or with modifications and/or translated into another
+language. (Hereinafter, translation is included without limitation in
+the term "modification".) Each licensee is addressed as "you".
+
+Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope. The act of
+running the Program is not restricted, and the output from the Program
+is covered only if its contents constitute a work based on the
+Program (independent of having been made by running the Program).
+Whether that is true depends on what the Program does.
+
+ 1. You may copy and distribute verbatim copies of the Program's
+source code as you receive it, in any medium, provided that you
+conspicuously and appropriately publish on each copy an appropriate
+copyright notice and disclaimer of warranty; keep intact all the
+notices that refer to this License and to the absence of any warranty;
+and give any other recipients of the Program a copy of this License
+along with the Program.
+
+You may charge a fee for the physical act of transferring a copy, and
+you may at your option offer warranty protection in exchange for a fee.
+
+ 2. You may modify your copy or copies of the Program or any portion
+of it, thus forming a work based on the Program, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+ a) You must cause the modified files to carry prominent notices
+ stating that you changed the files and the date of any change.
+
+ b) You must cause any work that you distribute or publish, that in
+ whole or in part contains or is derived from the Program or any
+ part thereof, to be licensed as a whole at no charge to all third
+ parties under the terms of this License.
+
+ c) If the modified program normally reads commands interactively
+ when run, you must cause it, when started running for such
+ interactive use in the most ordinary way, to print or display an
+ announcement including an appropriate copyright notice and a
+ notice that there is no warranty (or else, saying that you provide
+ a warranty) and that users may redistribute the program under
+ these conditions, and telling the user how to view a copy of this
+ License. (Exception: if the Program itself is interactive but
+ does not normally print such an announcement, your work based on
+ the Program is not required to print an announcement.)
+
+These requirements apply to the modified work as a whole. If
+identifiable sections of that work are not derived from the Program,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works. But when you
+distribute the same sections as part of a whole which is a work based
+on the Program, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Program.
+
+In addition, mere aggregation of another work not based on the Program
+with the Program (or with a work based on the Program) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+ 3. You may copy and distribute the Program (or a work based on it,
+under Section 2) in object code or executable form under the terms of
+Sections 1 and 2 above provided that you also do one of the following:
+
+ a) Accompany it with the complete corresponding machine-readable
+ source code, which must be distributed under the terms of Sections
+ 1 and 2 above on a medium customarily used for software interchange; or,
+
+ b) Accompany it with a written offer, valid for at least three
+ years, to give any third party, for a charge no more than your
+ cost of physically performing source distribution, a complete
+ machine-readable copy of the corresponding source code, to be
+ distributed under the terms of Sections 1 and 2 above on a medium
+ customarily used for software interchange; or,
+
+ c) Accompany it with the information you received as to the offer
+ to distribute corresponding source code. (This alternative is
+ allowed only for noncommercial distribution and only if you
+ received the program in object code or executable form with such
+ an offer, in accord with Subsection b above.)
+
+The source code for a work means the preferred form of the work for
+making modifications to it. For an executable work, complete source
+code means all the source code for all modules it contains, plus any
+associated interface definition files, plus the scripts used to
+control compilation and installation of the executable. However, as a
+special exception, the source code distributed need not include
+anything that is normally distributed (in either source or binary
+form) with the major components (compiler, kernel, and so on) of the
+operating system on which the executable runs, unless that component
+itself accompanies the executable.
+
+If distribution of executable or object code is made by offering
+access to copy from a designated place, then offering equivalent
+access to copy the source code from the same place counts as
+distribution of the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+ 4. You may not copy, modify, sublicense, or distribute the Program
+except as expressly provided under this License. Any attempt
+otherwise to copy, modify, sublicense or distribute the Program is
+void, and will automatically terminate your rights under this License.
+However, parties who have received copies, or rights, from you under
+this License will not have their licenses terminated so long as such
+parties remain in full compliance.
+
+ 5. You are not required to accept this License, since you have not
+signed it. However, nothing else grants you permission to modify or
+distribute the Program or its derivative works. These actions are
+prohibited by law if you do not accept this License. Therefore, by
+modifying or distributing the Program (or any work based on the
+Program), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Program or works based on it.
+
+ 6. Each time you redistribute the Program (or any work based on the
+Program), the recipient automatically receives a license from the
+original licensor to copy, distribute or modify the Program subject to
+these terms and conditions. You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+
+ 7. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License. If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Program at all. For example, if a patent
+license would not permit royalty-free redistribution of the Program by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Program.
+
+If any portion of this section is held invalid or unenforceable under
+any particular circumstance, the balance of the section is intended to
+apply and the section as a whole is intended to apply in other
+circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system, which is
+implemented by public license practices. Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+ 8. If the distribution and/or use of the Program is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Program under this License
+may add an explicit geographical distribution limitation excluding
+those countries, so that distribution is permitted only in or among
+countries not thus excluded. In such case, this License incorporates
+the limitation as if written in the body of this License.
+
+ 9. The Free Software Foundation may publish revised and/or new versions
+of the General Public License from time to time. Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+Each version is given a distinguishing version number. If the Program
+specifies a version number of this License which applies to it and "any
+later version", you have the option of following the terms and conditions
+either of that version or of any later version published by the Free
+Software Foundation. If the Program does not specify a version number of
+this License, you may choose any version ever published by the Free Software
+Foundation.
+
+ 10. If you wish to incorporate parts of the Program into other free
+programs whose distribution conditions are different, write to the author
+to ask for permission. For software which is copyrighted by the Free
+Software Foundation, write to the Free Software Foundation; we sometimes
+make exceptions for this. Our decision will be guided by the two goals
+of preserving the free status of all derivatives of our free software and
+of promoting the sharing and reuse of software generally.
+
+ NO WARRANTY
+
+ 11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
+FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN
+OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
+PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
+OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS
+TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE
+PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
+REPAIR OR CORRECTION.
+
+ 12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
+REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
+INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
+OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
+TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
+YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
+PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
+POSSIBILITY OF SUCH DAMAGES.
+
+ END OF TERMS AND CONDITIONS
+
+ How to Apply These Terms to Your New Programs
+
+ If you develop a new program, and you want it to be of the greatest
+possible use to the public, the best way to achieve this is to make it
+free software which everyone can redistribute and change under these terms.
+
+ To do so, attach the following notices to the program. It is safest
+to attach them to the start of each source file to most effectively
+convey the exclusion of warranty; and each file should have at least
+the "copyright" line and a pointer to where the full notice is found.
+
+ <one line to give the program's name and a brief idea of what it does.>
+ Copyright (C) <year> <name of author>
+
+ This program is free software: you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation, either version 2 of the License, or
+ (at your option) any later version.
+
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License
+ along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+Also add information on how to contact you by electronic and paper mail.
+
+If the program is interactive, make it output a short notice like this
+when it starts in an interactive mode:
+
+ Gnomovision version 69, Copyright (C) <year> <name of author>
+ Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
+ This is free software, and you are welcome to redistribute it
+ under certain conditions; type `show c' for details.
+
+The hypothetical commands `show w' and `show c' should show the appropriate
+parts of the General Public License. Of course, the commands you use may
+be called something other than `show w' and `show c'; they could even be
+mouse-clicks or menu items--whatever suits your program.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the program, if
+necessary. Here is a sample; alter the names:
+
+ Yoyodyne, Inc., hereby disclaims all copyright interest in the program
+ `Gnomovision' (which makes passes at compilers) written by James Hacker.
+
+ <signature of Ty Coon>, 1 April 1989
+ Ty Coon, President of Vice
+
+This General Public License does not permit incorporating your program into
+proprietary programs. If your program is a subroutine library, you may
+consider it more useful to permit linking proprietary applications with the
+library. If this is what you want to do, use the GNU Lesser General
+Public License instead of this License.
+ GNU GENERAL PUBLIC LICENSE
+ Version 2, June 1991
+
+ Copyright (C) 1989, 1991 Free Software Foundation, Inc.,
+ 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+ Preamble
+
+ The licenses for most software are designed to take away your
+freedom to share and change it. By contrast, the GNU General Public
+License is intended to guarantee your freedom to share and change free
+software--to make sure the software is free for all its users. This
+General Public License applies to most of the Free Software
+Foundation's software and to any other program whose authors commit to
+using it. (Some other Free Software Foundation software is covered by
+the GNU Lesser General Public License instead.) You can apply it to
+your programs, too.
+
+ When we speak of free software, we are referring to freedom, not
+price. Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+this service if you wish), that you receive source code or can get it
+if you want it, that you can change the software or use pieces of it
+in new free programs; and that you know you can do these things.
+
+ To protect your rights, we need to make restrictions that forbid
+anyone to deny you these rights or to ask you to surrender the rights.
+These restrictions translate to certain responsibilities for you if you
+distribute copies of the software, or if you modify it.
+
+ For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must give the recipients all the rights that
+you have. You must make sure that they, too, receive or can get the
+source code. And you must show them these terms so they know their
+rights.
+
+ We protect your rights with two steps: (1) copyright the software, and
+(2) offer you this license which gives you legal permission to copy,
+distribute and/or modify the software.
+
+ Also, for each author's protection and ours, we want to make certain
+that everyone understands that there is no warranty for this free
+software. If the software is modified by someone else and passed on, we
+want its recipients to know that what they have is not the original, so
+that any problems introduced by others will not reflect on the original
+authors' reputations.
+
+ Finally, any free program is threatened constantly by software
+patents. We wish to avoid the danger that redistributors of a free
+program will individually obtain patent licenses, in effect making the
+program proprietary. To prevent this, we have made it clear that any
+patent must be licensed for everyone's free use or not licensed at all.
+
+ The precise terms and conditions for copying, distribution and
+modification follow.
+
+ GNU GENERAL PUBLIC LICENSE
+ TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+ 0. This License applies to any program or other work which contains
+a notice placed by the copyright holder saying it may be distributed
+under the terms of this General Public License. The "Program", below,
+refers to any such program or work, and a "work based on the Program"
+means either the Program or any derivative work under copyright law:
+that is to say, a work containing the Program or a portion of it,
+either verbatim or with modifications and/or translated into another
+language. (Hereinafter, translation is included without limitation in
+the term "modification".) Each licensee is addressed as "you".
+
+Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope. The act of
+running the Program is not restricted, and the output from the Program
+is covered only if its contents constitute a work based on the
+Program (independent of having been made by running the Program).
+Whether that is true depends on what the Program does.
+
+ 1. You may copy and distribute verbatim copies of the Program's
+source code as you receive it, in any medium, provided that you
+conspicuously and appropriately publish on each copy an appropriate
+copyright notice and disclaimer of warranty; keep intact all the
+notices that refer to this License and to the absence of any warranty;
+and give any other recipients of the Program a copy of this License
+along with the Program.
+
+You may charge a fee for the physical act of transferring a copy, and
+you may at your option offer warranty protection in exchange for a fee.
+
+ 2. You may modify your copy or copies of the Program or any portion
+of it, thus forming a work based on the Program, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+ a) You must cause the modified files to carry prominent notices
+ stating that you changed the files and the date of any change.
+
+ b) You must cause any work that you distribute or publish, that in
+ whole or in part contains or is derived from the Program or any
+ part thereof, to be licensed as a whole at no charge to all third
+ parties under the terms of this License.
+
+ c) If the modified program normally reads commands interactively
+ when run, you must cause it, when started running for such
+ interactive use in the most ordinary way, to print or display an
+ announcement including an appropriate copyright notice and a
+ notice that there is no warranty (or else, saying that you provide
+ a warranty) and that users may redistribute the program under
+ these conditions, and telling the user how to view a copy of this
+ License. (Exception: if the Program itself is interactive but
+ does not normally print such an announcement, your work based on
+ the Program is not required to print an announcement.)
+
+These requirements apply to the modified work as a whole. If
+identifiable sections of that work are not derived from the Program,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works. But when you
+distribute the same sections as part of a whole which is a work based
+on the Program, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Program.
+
+In addition, mere aggregation of another work not based on the Program
+with the Program (or with a work based on the Program) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+ 3. You may copy and distribute the Program (or a work based on it,
+under Section 2) in object code or executable form under the terms of
+Sections 1 and 2 above provided that you also do one of the following:
+
+ a) Accompany it with the complete corresponding machine-readable
+ source code, which must be distributed under the terms of Sections
+ 1 and 2 above on a medium customarily used for software interchange; or,
+
+ b) Accompany it with a written offer, valid for at least three
+ years, to give any third party, for a charge no more than your
+ cost of physically performing source distribution, a complete
+ machine-readable copy of the corresponding source code, to be
+ distributed under the terms of Sections 1 and 2 above on a medium
+ customarily used for software interchange; or,
+
+ c) Accompany it with the information you received as to the offer
+ to distribute corresponding source code. (This alternative is
+ allowed only for noncommercial distribution and only if you
+ received the program in object code or executable form with such
+ an offer, in accord with Subsection b above.)
+
+The source code for a work means the preferred form of the work for
+making modifications to it. For an executable work, complete source
+code means all the source code for all modules it contains, plus any
+associated interface definition files, plus the scripts used to
+control compilation and installation of the executable. However, as a
+special exception, the source code distributed need not include
+anything that is normally distributed (in either source or binary
+form) with the major components (compiler, kernel, and so on) of the
+operating system on which the executable runs, unless that component
+itself accompanies the executable.
+
+If distribution of executable or object code is made by offering
+access to copy from a designated place, then offering equivalent
+access to copy the source code from the same place counts as
+distribution of the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+ 4. You may not copy, modify, sublicense, or distribute the Program
+except as expressly provided under this License. Any attempt
+otherwise to copy, modify, sublicense or distribute the Program is
+void, and will automatically terminate your rights under this License.
+However, parties who have received copies, or rights, from you under
+this License will not have their licenses terminated so long as such
+parties remain in full compliance.
+
+ 5. You are not required to accept this License, since you have not
+signed it. However, nothing else grants you permission to modify or
+distribute the Program or its derivative works. These actions are
+prohibited by law if you do not accept this License. Therefore, by
+modifying or distributing the Program (or any work based on the
+Program), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Program or works based on it.
+
+ 6. Each time you redistribute the Program (or any work based on the
+Program), the recipient automatically receives a license from the
+original licensor to copy, distribute or modify the Program subject to
+these terms and conditions. You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+
+ 7. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License. If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Program at all. For example, if a patent
+license would not permit royalty-free redistribution of the Program by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Program.
+
+If any portion of this section is held invalid or unenforceable under
+any particular circumstance, the balance of the section is intended to
+apply and the section as a whole is intended to apply in other
+circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system, which is
+implemented by public license practices. Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+ 8. If the distribution and/or use of the Program is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Program under this License
+may add an explicit geographical distribution limitation excluding
+those countries, so that distribution is permitted only in or among
+countries not thus excluded. In such case, this License incorporates
+the limitation as if written in the body of this License.
+
+ 9. The Free Software Foundation may publish revised and/or new versions
+of the General Public License from time to time. Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+Each version is given a distinguishing version number. If the Program
+specifies a version number of this License which applies to it and "any
+later version", you have the option of following the terms and conditions
+either of that version or of any later version published by the Free
+Software Foundation. If the Program does not specify a version number of
+this License, you may choose any version ever published by the Free Software
+Foundation.
+
+ 10. If you wish to incorporate parts of the Program into other free
+programs whose distribution conditions are different, write to the author
+to ask for permission. For software which is copyrighted by the Free
+Software Foundation, write to the Free Software Foundation; we sometimes
+make exceptions for this. Our decision will be guided by the two goals
+of preserving the free status of all derivatives of our free software and
+of promoting the sharing and reuse of software generally.
+
+ NO WARRANTY
+
+ 11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
+FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN
+OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
+PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
+OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS
+TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE
+PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
+REPAIR OR CORRECTION.
+
+ 12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
+REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
+INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
+OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
+TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
+YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
+PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
+POSSIBILITY OF SUCH DAMAGES.
+
+ END OF TERMS AND CONDITIONS
+
+ How to Apply These Terms to Your New Programs
+
+ If you develop a new program, and you want it to be of the greatest
+possible use to the public, the best way to achieve this is to make it
+free software which everyone can redistribute and change under these terms.
+
+ To do so, attach the following notices to the program. It is safest
+to attach them to the start of each source file to most effectively
+convey the exclusion of warranty; and each file should have at least
+the "copyright" line and a pointer to where the full notice is found.
+
+ <one line to give the program's name and a brief idea of what it does.>
+ Copyright (C) <year> <name of author>
+
+ This program is free software: you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation, either version 2 of the License, or
+ (at your option) any later version.
+
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License
+ along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+Also add information on how to contact you by electronic and paper mail.
+
+If the program is interactive, make it output a short notice like this
+when it starts in an interactive mode:
+
+ Gnomovision version 69, Copyright (C) <year> <name of author>
+ Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
+ This is free software, and you are welcome to redistribute it
+ under certain conditions; type `show c' for details.
+
+The hypothetical commands `show w' and `show c' should show the appropriate
+parts of the General Public License. Of course, the commands you use may
+be called something other than `show w' and `show c'; they could even be
+mouse-clicks or menu items--whatever suits your program.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the program, if
+necessary. Here is a sample; alter the names:
+
+ Yoyodyne, Inc., hereby disclaims all copyright interest in the program
+ `Gnomovision' (which makes passes at compilers) written by James Hacker.
+
+ <signature of Ty Coon>, 1 April 1989
+ Ty Coon, President of Vice
+
+This General Public License does not permit incorporating your program into
+proprietary programs. If your program is a subroutine library, you may
+consider it more useful to permit linking proprietary applications with the
+library. If this is what you want to do, use the GNU Lesser General
+Public License instead of this License.
diff --git a/testsuite/test.txt.lz b/testsuite/test.txt.lz
new file mode 100644
index 0000000..46f98a7
--- /dev/null
+++ b/testsuite/test.txt.lz
Binary files differ
diff --git a/testsuite/test.txt.tar b/testsuite/test.txt.tar
new file mode 100644
index 0000000..d687b43
--- /dev/null
+++ b/testsuite/test.txt.tar
Binary files differ
diff --git a/testsuite/test.txt.tar.lz b/testsuite/test.txt.tar.lz
new file mode 100644
index 0000000..15c0131
--- /dev/null
+++ b/testsuite/test.txt.tar.lz
Binary files differ
diff --git a/testsuite/test3.tar b/testsuite/test3.tar
new file mode 100644
index 0000000..d58fb45
--- /dev/null
+++ b/testsuite/test3.tar
Binary files differ
diff --git a/testsuite/test3.tar.lz b/testsuite/test3.tar.lz
new file mode 100644
index 0000000..779ace4
--- /dev/null
+++ b/testsuite/test3.tar.lz
Binary files differ
diff --git a/testsuite/test3_bad1.tar b/testsuite/test3_bad1.tar
new file mode 100644
index 0000000..005b6a3
--- /dev/null
+++ b/testsuite/test3_bad1.tar
Binary files differ
diff --git a/testsuite/test3_bad1.tar.lz b/testsuite/test3_bad1.tar.lz
new file mode 100644
index 0000000..9f5d40f
--- /dev/null
+++ b/testsuite/test3_bad1.tar.lz
Binary files differ
diff --git a/testsuite/test3_bad2.tar b/testsuite/test3_bad2.tar
new file mode 100644
index 0000000..d2c546b
--- /dev/null
+++ b/testsuite/test3_bad2.tar
Binary files differ
diff --git a/testsuite/test3_bad2.tar.lz b/testsuite/test3_bad2.tar.lz
new file mode 100644
index 0000000..182c048
--- /dev/null
+++ b/testsuite/test3_bad2.tar.lz
Binary files differ
diff --git a/testsuite/test3_bad3.tar b/testsuite/test3_bad3.tar
new file mode 100644
index 0000000..7d78e87
--- /dev/null
+++ b/testsuite/test3_bad3.tar
Binary files differ
diff --git a/testsuite/test3_bad3.tar.lz b/testsuite/test3_bad3.tar.lz
new file mode 100644
index 0000000..c711a1a
--- /dev/null
+++ b/testsuite/test3_bad3.tar.lz
Binary files differ
diff --git a/testsuite/test3_bad4.tar b/testsuite/test3_bad4.tar
new file mode 100644
index 0000000..68312b3
--- /dev/null
+++ b/testsuite/test3_bad4.tar
Binary files differ
diff --git a/testsuite/test3_bad4.tar.lz b/testsuite/test3_bad4.tar.lz
new file mode 100644
index 0000000..226db72
--- /dev/null
+++ b/testsuite/test3_bad4.tar.lz
Binary files differ
diff --git a/testsuite/test3_bad5.tar b/testsuite/test3_bad5.tar
new file mode 100644
index 0000000..e482969
--- /dev/null
+++ b/testsuite/test3_bad5.tar
Binary files differ
diff --git a/testsuite/test3_bad5.tar.lz b/testsuite/test3_bad5.tar.lz
new file mode 100644
index 0000000..5b4feb3
--- /dev/null
+++ b/testsuite/test3_bad5.tar.lz
Binary files differ
diff --git a/testsuite/test3_bad6.tar.lz b/testsuite/test3_bad6.tar.lz
new file mode 100644
index 0000000..42b3888
--- /dev/null
+++ b/testsuite/test3_bad6.tar.lz
Binary files differ
diff --git a/testsuite/test3a.tar.lz b/testsuite/test3a.tar.lz
new file mode 100644
index 0000000..8eb3f43
--- /dev/null
+++ b/testsuite/test3a.tar.lz
Binary files differ